/* 
   StarDateApplet - Applet that displays the current stardate
   $Id: StarDateApplet.java,v 1.1 2003/04/17 17:31:39 ranga Exp $
*/

import java.applet.*;
import java.awt.*;

public class StarDateApplet extends Applet implements Runnable {

  private Thread sdThread = null;
  private Label sdLabel;
  private StarDate sd;

  private long DELAY=5000;
  
  public void init() {
    sd = new StarDate();
    setFont(new Font("Helvetica",Font.ITALIC + Font.BOLD,18));
    setColors();
    sdLabel = new Label(sd.toString());
    add("Center",sdLabel);
  }

  public void start() {
    if (sdThread == null) {
      sdThread = new Thread(this,"sdThread");	
      sdThread.start();				
    }
  }

  public void stop() {
    if ((sdThread != null) && sdThread.isAlive()) 
      sdThread.stop();	
    sdThread = null;
  }

  public void run () {
    while(true) {
      sdLabel.setText(sd.toString());
      try { 
	Thread.sleep(DELAY); 
      } catch (InterruptedException e) { 
	return ; 
      }
    }
  }

  /* Set the colors for the applet from parameters */

  private void setColors() {
    Color foreground,background;

    /* set the foreground color */

    foreground = getColorParameter("foreground");
    if (foreground == null) foreground = Color.blue ;
    setForeground(foreground);
		
    /* set the background color */

    background = getColorParameter("background");
    if (background == null) background = Color.white ;
    setBackground(background);
  }

  /* Get the color parameters and convert to Color */
  private Color getColorParameter(String color_name) {
    int color_value;
    
    try {
      color_value = Integer.parseInt(getParameter(color_name),16);
    } catch (NumberFormatException e) {
      return null;
    }
    
    return new Color(color_value);
  }
}
